# Spielfeld und Spielobjekte verwenden
from Spielfeld import *
from Spielobjekt import *


# Spielfeld erzeugen
spielfeld = Spielfeld()

# Gelben Fisch erzeugen
fischGelb = Spielobjekt()
fischGelb.text = "Spieler 1: Pfeiltasten"
fischGelb.textfarbe = "green"
fischGelb.bildname = "FischGelbAufRechts.gif"
fischGelb.breite = 50
fischGelb.höhe = 50
fischGelb.positionX = 10
fischGelb.positionY = 40

# Rosafarbenen Fisch erzeugen
fischRosa = Spielobjekt()
fischRosa.text = "Spieler 2: A,S,D,W"
fischRosa.textfarbe = "red"
fischRosa.bildname = "FischRosaAufRechts.gif"
fischRosa.breite = 50
fischRosa.höhe = 50
fischRosa.positionX = spielfeld.breite - fischRosa.breite - 60
fischRosa.positionY = spielfeld.höhe - fischRosa.höhe - 10

# Qualle erzeugen
qualle = Spielobjekt()
qualle.bildname = "QualleZu.gif"
qualle.breite = 50
qualle.höhe = 50
qualle.positionX = spielfeld.breite / 2 - qualle.breite / 2
qualle.positionY = spielfeld.höhe / 2 - qualle.höhe / 2

# Spielobjekte dem Spielfeld hinzufügen
spielfeld.hinzufügen( fischGelb )
spielfeld.hinzufügen( fischRosa )
spielfeld.hinzufügen( qualle )

# Zähler für Schleifendurchgänge
zähler = 0

# Hauptschleife: Fortlaufend wiederholen
while True:

    # Schleifenzähler erhöhen
    zähler = zähler + 1

    # Gelben fisch bewegen
    fischGelb.positionX = fischGelb.positionX + fischGelb.richtungX * 5
    fischGelb.positionY = fischGelb.positionY + fischGelb.richtungY * 5

    # Tastatureingaben für gelben Fisch verarbeiten
    if spielfeld.rechtsGedrückt:
        fischGelb.richtungY = 0
        fischGelb.richtungX = 1
    elif spielfeld.linksGedrückt:
        fischGelb.richtungY = 0
        fischGelb.richtungX = -1
    elif spielfeld.obenGedrückt:
        fischGelb.richtungX = 0
        fischGelb.richtungY = -1
    elif spielfeld.untenGedrückt:
        fischGelb.richtungX = 0
        fischGelb.richtungY = 1

    # Gelben Fisch animieren
    if fischGelb.richtungX == 1:
        if fischGelb.bildname == "FischGelbAufRechts.gif":
            fischGelb.bildname = "FischGelbZuRechts.gif"
            fischGelb.klangAbspielen( "Biss.wav" )
        else:
            fischGelb.bildname = "FischGelbAufRechts.gif"
    elif fischGelb.richtungX == -1:
        if fischGelb.bildname == "FischGelbAufLinks.gif":
            fischGelb.bildname = "FischGelbZuLinks.gif"
            fischGelb.klangAbspielen( "Biss.wav" )
        else:
            fischGelb.bildname = "FischGelbAufLinks.gif"
    elif fischGelb.richtungY == 1:
        if fischGelb.bildname == "FischGelbAufUnten.gif":
            fischGelb.bildname = "FischGelbZuUnten.gif"
            fischGelb.klangAbspielen( "Biss.wav" )
        else:
            fischGelb.bildname = "FischGelbAufUnten.gif"
    elif fischGelb.richtungY == -1:
        if fischGelb.bildname == "FischGelbAufOben.gif":
            fischGelb.bildname = "FischGelbZuOben.gif"
            fischGelb.klangAbspielen( "Biss.wav" )
        else:
            fischGelb.bildname = "FischGelbAufOben.gif"
                
    # Rosafarbenen Fisch bewegen
    fischRosa.positionX = fischRosa.positionX + fischRosa.richtungX * 5
    fischRosa.positionY = fischRosa.positionY + fischRosa.richtungY * 5

    # Tastatureingaben für rosafarbenen Fisch verarbeiten
    if spielfeld.tasteGedrückt == "d":
        fischRosa.richtungY = 0
        fischRosa.richtungX = 1
    elif spielfeld.tasteGedrückt == "a":
        fischRosa.richtungY = 0
        fischRosa.richtungX = -1
    elif spielfeld.tasteGedrückt == "w":
        fischRosa.richtungX = 0
        fischRosa.richtungY = -1
    elif spielfeld.tasteGedrückt == "s":
        fischRosa.richtungX = 0
        fischRosa.richtungY = 1

    # Rosafarbenen Fisch animieren
    if fischRosa.richtungX == 1:
        if fischRosa.bildname == "FischRosaAufRechts.gif":
            fischRosa.bildname = "FischRosaZuRechts.gif"
            fischRosa.klangAbspielen( "Biss.wav" )
        else:
            fischRosa.bildname = "FischRosaAufRechts.gif"
    elif fischRosa.richtungX == -1:
        if fischRosa.bildname == "FischRosaAufLinks.gif":
            fischRosa.bildname = "FischRosaZuLinks.gif"
            fischRosa.klangAbspielen( "Biss.wav" )
        else:
            fischRosa.bildname = "FischRosaAufLinks.gif"
    elif fischRosa.richtungY == 1:
        if fischRosa.bildname == "FischRosaAufUnten.gif":
            fischRosa.bildname = "FischRosaZuUnten.gif"
            fischRosa.klangAbspielen( "Biss.wav" )
        else:
            fischRosa.bildname = "FischRosaAufUnten.gif"
    elif fischRosa.richtungY == -1:
        if fischRosa.bildname == "FischRosaAufOben.gif":
            fischRosa.bildname = "FischRosaZuOben.gif"
            fischRosa.klangAbspielen( "Biss.wav" )
        else:
            fischRosa.bildname = "FischRosaAufOben.gif"

    # Qualle bewegen
    qualle.positionX = qualle.positionX + qualle.richtungX * 5
    qualle.positionY = qualle.positionY + qualle.richtungY * 5

    # Qualle steuern (Richtungsänderung alle 20 Schleifendurchgänge)
    if zähler % 20 == 0:
        qualle.richtungX = 0
        qualle.richtungY = 0
        zufallszahl = qualle.zufallszahl( 1, 5 )
        if zufallszahl == 1:
            qualle.richtungX = 1
        elif zufallszahl == 2:
            qualle.richtungX = -1
        elif zufallszahl == 3:
            qualle.richtungY = 1
        elif zufallszahl == 4:
            qualle.richtungY = -1

    # Qualle animieren
    if qualle.bildname == "QualleZu.gif":
        qualle.bildname = "QualleAuf.gif"
    else:
        qualle.bildname = "QualleZu.gif"

    # Kollision mit gelbem Fisch oder rosafarbenem Fisch abfragen
    if fischGelb.berührt( qualle ) or fischRosa.berührt( qualle ) :
        qualle.unsichtbar = True

    # Spielfeld aktualisieren
    spielfeld.zeichnen()

    # Etwas warten, damit Spiel nicht zu schnell läuft
    spielfeld.warten( 100 )
