class Spielobjekt:
    """Objekte dieser Klasse stellen Spielobjekte dar. VERSION: 1.1.0"""


    def __init__( self ):
        """Konstruktor eines Spielobjektes: Erzeugt ein neues Spielobjekt."""

        # Der Dateiname des zum Spielobjekt gehörigen Bildes
        self.bildname = ""
	
        # Die x-Koordinate der linken oberen Ecke des Spielobjektes
        self.positionX = 0

        # Die y-Koordinate der linken oberen Ecke des Spielobjektes
        self.positionY = 0
	
        # Die x-Richtung des Spielobjektes
        self.richtungX = 0

        # Die y-Richtung des Spielobjektes
        self.richtungY = 0

        # Die Höhe des Spielobjektes
        self.höhe = 0

        # Die Breite des Spielobjektes
        self.breite = 0
	
        # Der Text, der zusätzlich zum Spielobjekt angezeigt werden soll
        self.text = ""

        # Die Farbe des Textes, der zusätzlich zum Spielobjekt angezeigt werden soll
        self.textfarbe = "black"

        # Gibt an, ob ein Spielobjekt sichtbar ist
        self.unsichtbar = False


    def berührt( self, spielobjekt ):
        """Gibt zurück ob das Spielobjekt das andere Spielobjekt berührt."""

        # Für jede Ecke des Spielobjekts prüfen, ob sie innerhalb des anderen Spielobjekts liegt und umgekehrt oder ob das eine über dem anderen Spielobjekt liegt (ohne die Ecken)!
        if    (self.positionX >= spielobjekt.positionX and self.positionX <= spielobjekt.positionX + spielobjekt.breite - 1 and self.positionY >= spielobjekt.positionY and self.positionY <= spielobjekt.positionY + spielobjekt.höhe - 1) \
           or (self.positionX + self.breite - 1 >= spielobjekt.positionX and self.positionX + self.breite - 1 <= spielobjekt.positionX + spielobjekt.breite - 1 and self.positionY >= spielobjekt.positionY and self.positionY <= spielobjekt.positionY + spielobjekt.höhe - 1) \
           or (self.positionX + self.breite - 1 >= spielobjekt.positionX and self.positionX + self.breite - 1 <= spielobjekt.positionX + spielobjekt.breite - 1 and self.positionY + self.höhe - 1 >= spielobjekt.positionY and self.positionY + self.höhe - 1 <= spielobjekt.positionY + spielobjekt.höhe - 1) \
           or (self.positionX >= spielobjekt.positionX and self.positionX <= spielobjekt.positionX + spielobjekt.breite - 1 and self.positionY + self.höhe - 1 >= spielobjekt.positionY and self.positionY + self.höhe - 1 <= spielobjekt.positionY + spielobjekt.höhe - 1) \
           or (self.positionX >= spielobjekt.positionX and self.positionX <= spielobjekt.positionX + spielobjekt.breite - 1 and self.positionX + self.breite - 1 <= spielobjekt.positionX + spielobjekt.breite - 1 and self.positionY <= spielobjekt.positionY and self.positionY + self.höhe - 1 >= spielobjekt.positionY + spielobjekt.höhe - 1) \
           or (spielobjekt.positionX >= self.positionX and spielobjekt.positionX <= self.positionX + self.breite - 1 and spielobjekt.positionY >= self.positionY and spielobjekt.positionY <= self.positionY + self.höhe - 1) \
           or (spielobjekt.positionX + spielobjekt.breite - 1 >= self.positionX and spielobjekt.positionX + spielobjekt.breite - 1 <= self.positionX + self.breite - 1 and spielobjekt.positionY >= self.positionY and spielobjekt.positionY <= self.positionY + self.höhe - 1) \
           or (spielobjekt.positionX + spielobjekt.breite - 1 >= self.positionX and spielobjekt.positionX + spielobjekt.breite - 1 <= self.positionX + self.breite - 1 and spielobjekt.positionY + spielobjekt.höhe - 1 >= self.positionY and spielobjekt.positionY + spielobjekt.höhe - 1 <= self.positionY + self.höhe - 1) \
           or (spielobjekt.positionX >= self.positionX and spielobjekt.positionX <= self.positionX + self.breite - 1 and spielobjekt.positionY + spielobjekt.höhe - 1 >= self.positionY and spielobjekt.positionY + spielobjekt.höhe - 1 <= self.positionY + self.höhe - 1) \
           or (spielobjekt.positionX >= self.positionX and spielobjekt.positionX <= self.positionX + self.breite - 1 and spielobjekt.positionX + spielobjekt.breite - 1 <= self.positionX + self.breite - 1 and spielobjekt.positionY <= self.positionY and spielobjekt.positionY + spielobjekt.höhe - 1 >= self.positionY + self.höhe - 1):
            return True
        else:
            return False

    
    def zufallszahl( self, von, bis ):
        """Gibt eine Zufallszahl im angegebenen Bereich zurück (jeweils einschließlich der angegebenen Grenzen)."""

        return( Spielfeld.zufallszahl( von, bis ) )


    def klangAbspielen( self, dateiname, wiederholen = False ):
        """Spielt den Klang mit dem angegebenen Dateinamen ab. Funktioniert nur unter Windows."""

        Spielfeld.klangAbspielen( dateiname, wiederholen )


    def klangStoppen( self ):
        """Stoppt das Abspielen des Klangs. Funktioniert nur unter Windows."""

        Spielfeld.klangStoppen()


    def berechnen( self ):
        """Neue Spielobjekt-Klassen, die von der Klasse "Spielobjekt" abgeleitet werden können diese Methode füllen, um Berechnungen wie Bewegung oder anderes Verhalten umzusetzen."""
        
        pass


from Spielfeld import Spielfeld
